#include <stdio.h>
#define MINIZ_IMPLEMENTATION
#include "../imports/miniz.c"

typedef struct
{
  char *name;
  unsigned char *data;
  int len;
} code_t;

static const code_t codes[]= {
#include "libdata.cx"
 {NULL }
};

#define OUT_BUFFER_SIZE 4096


static int decompress_code(const unsigned char *inp, int len, FILE *out)
{
  int R;
  size_t olen;
  mz_stream MZ;
  unsigned char outbuffer[OUT_BUFFER_SIZE];

  memset(&MZ, 0, sizeof(MZ));
  MZ.next_in= inp;
  MZ.avail_in= len;
  MZ.next_out= outbuffer;
  MZ.avail_out= OUT_BUFFER_SIZE;

  mz_inflateInit(&MZ);
  do {
    R= mz_inflate(&MZ, MZ_NO_FLUSH );
    olen= OUT_BUFFER_SIZE - MZ.avail_out;
    if (olen) fwrite(outbuffer,1,olen,out);
    MZ.next_out= outbuffer;
    MZ.avail_out= OUT_BUFFER_SIZE;
  } while(R!=MZ_STREAM_END);
  fprintf(stderr,"Done\n");
  mz_inflateEnd(&MZ);
  return 0;
}

void print_code(char *name, FILE *out)
{
  int i;
  for(i=0;codes[i].name;i++)
   if (!strcmp(codes[i].name, name))
   {
     decompress_code(codes[i].data, codes[i].len, out);
     break;
   }
}

#if 0
int main(int argc,char **argv)
{
  print_code(argv[1], stdout);
  return 0;
}
#endif
