/***********************************************************************
 *                                                                     *
 *                             PROTOTYPES                              *
 *                                                                     *
 ***********************************************************************/
static void init_guibc_globals();
static void init_data();
static int vkey_event(gfx_event_t *ev);

static void free_rgroups(screen_t *S);
static int getdpi();
static void gfx_update_all();

static unsigned int* gui_R_COLORIMG_toserver(R_COLORIMG *img);

 //----------- Widget Methods ----------------//
 // These functions are called from implemen- //
 // tations of widgets and builtin dialogs.   //
 // Public functions are called gfx_*.        //
 //-------------------------------------------//
static char* widget_get_text(widget_t *W);
static void widget_set_text(widget_t *W, char *str);
static void widget_show(widget_t *W, int show);
static void widget_move(widget_t *W,int x,int y,int w,int h);
static void widget_destroy(widget_t* W);
static void widget_set_state(widget_t *W, int state);
static int widget_get_state(widget_t *W);
static int widget_get_selected(widget_t *W);
static void widget_set_selected(widget_t *W,int sel);
static void widget_set_fgbg(widget_t *W,int fg,int bg);
static void widget_insert
  (widget_t *W,int pos, char *text, void *user, uint32_t *icon);
static void widget_remove(widget_t *W,int pos, void **Ruser);
static void widget_clear(widget_t *W);

static gui_icon_t *gui_get_icon(int icon_no);

