
/***********************************************************************
 *                                                                     *
 *                              VARIABLES                              *
 *                                                                     *
 ***********************************************************************/

 // On Android, these are constants
#ifdef GFX_X11
static uint32_t x_red_mask, x_red_shift,
                x_green_mask, x_green_shift,
                x_blue_mask, x_blue_shift;
#endif
#ifdef GFX_FB
static uint32_t x_red_mask, x_red_shift,
x_green_mask, x_green_shift,
x_blue_mask, x_blue_shift;
#endif
static int      x_window_width, x_window_height;
static uint32_t **x_image_data;

static womap_t *gfx_objid_map;

static uint32_t objid(int type, int id)
{
  uint32_t V;
  V= (type<<24) | id;
  return V;
}

static void* obj_get(int type, int id)
{
  if (!gfx_objid_map) return NULL;
  return womap_find(gfx_objid_map, objid(type,id));
}

static void* obj_put(int type, int id, void *data)
{
  if (!gfx_objid_map) gfx_objid_map= womap_new();
  return womap_insert(gfx_objid_map, objid(type,id), data);
}

static void* obj_remove(int type, int id)
{
  if (!gfx_objid_map) return NULL;
  return womap_remove(gfx_objid_map, objid(type,id));
}



// The list of widgets is held inside a regular array.
// It doesn't grow or shrink. This is allocated by gfx_data.
static widget_t **widgets;
static int first_widget_no, last_widget_no;

static widget_t *get_widget(int wno)
{
  if (wno<first_widget_no || wno>last_widget_no) return NULL;
  return widgets[wno];
}

static void *get_widgetk(int wno,int klass)
{
  widget_t *W;
  W= get_widget(wno);
  if (!W) return NULL;
  if (W->klass!=klass) return NULL;
  return W;
}

static void widgetpos(widget_t *W,int x,int y,int w,int h)
{
  W->x= x; W->y= y; W->w= w; W->h= h;
}

/***********************************************************************
  The following function is used for widgets where there is no work to
  be done in case a widget is hidden.
 ***********************************************************************/
static void generic_dummy_hide(widget_t *W) { }



// #W.RADIO


static unsigned int  gfx_radio_width, gfx_radio_height;

  /***  #W.SCROLLBAR
In order to provide the user with proper width/height, we need some
constants. These are initialized in init_buttons().
  ***/
static unsigned int gui_scrollbar_width;
static unsigned int gui_scrollbar_height;

   // updates can be turned on and off, this can prevent flickering
   // situations
static int updates_on= 1;

  // This variable makes sense only for the Android platform.
  // However, it's used in layout code which is platform
  // independent. Therefore, it must exist no matter what the
  // platform is. On X11, it's defined to be 0 so that it
  // doesn't affect the layout there.
#ifdef GFX_ANDROID
static int gui_sysbar_height = 25;
#else
static int gui_sysbar_height = 0;
#endif
  //below comment is a MARK, do not remove
/** USER RESOURCES **/

