#include <stdlib.h>
#include <stdint.h>
#include <stdio.h>
#include "gfx.h"
#include "pngio.h"


static int pw,ph,bw,bh;
static uint32_t *pdata,*bdata;

static void load_file(char *fn, int *Rw,int *Rh,uint32_t **Rdata)
{
 char *e;
 e= read_png_image(fn,Rw,Rh,Rdata);
  if (e) exit(fprintf(stderr,"can't read %s: %s\n",fn,e));
}



int main(int argc,char **argv)
{
  gfx_event_t ev;
  int dw,dh;
  unsigned int *dd;
  int i,x,y;

  load_file(argv[1],&pw,&ph,&pdata);
  load_file(argv[2],&bw,&bh,&bdata);
  gfx_init(NULL, 600, 400, "Testing");
  gfx_SCREEN_0();
 
  gfx_canvas_setsize(Wcan, bw, bh);

  gfx_canvas_get_buffer(Wcan, &dw,&dh,&dd);
  for(y=0;y<bh;y++)
  {
     if (y>=dh) break;
     for(x=0;x<bw;x++)
     {
       if (x>=dw) break;
       dd[x+y*dw]= bdata[x+y*bw];
     }
  }
  gfx_canvas_update(Wcan, 0,0,dw,dh);

  
  for(i=0;i<pw*ph;i++) pdata[i]&= ~(0xff<<24);
  for(i=0;i<pw*ph;i++) if (pdata[i]) pdata[i] |= (0xff<<24);

  int ss= gfx_sprite_new(Wcan, 'N', pw, ph, pdata);

  while(1)
    if (gfx_event(NULL,&ev))
     switch(ev.type)
     {
     case GFXEV_QUIT: goto done;
     case GFXEV(Wcan,BUTTON_PRESS):
       gfx_canvas_begin_report_mouse_position(Wcan);
       gfx_sprite_move(Wcan, ss, ev.x-pw/2, ev.y-ph/2);
       gfx_sprite_show(Wcan, ss, 1);
       break;
     case GFXEV(Wcan,BUTTON_RELEASE):
       gfx_canvas_end_report_mouse_position(Wcan);
       gfx_sprite_show(Wcan, ss, 0);
       break;
     case GFXEV(Wcan,POINTER_MOVE):
       gfx_sprite_move(Wcan, ss, ev.x-pw/2, ev.y-ph/2);
       break;
     }
done:
  gfx_sprite_remove(Wcan, ss);
  gfx_close();
}
