#include <stdlib.h>
#include <stdint.h>
#include <stdio.h>
#include "gfx.h"
#include "rjpg.h"
#include "resize_image.h"


static int pw,ph,bw,bh;
static uint32_t *pdata,*bdata;

static void load_file(char *fn,int w,int h, int *Rw,int *Rh,uint32_t **Rdata)
{
 char *e;
  int iw, ih, *idata;
 if (read_jpeg(fn, &iw, &ih, &idata))
   exit(fprintf(stderr,"can't read %s\n",fn));
 resize_image_argb((unsigned int*) idata, iw, ih,
     w,h, Rdata, Rw, Rh);
  free(idata);
}



int main(int argc,char **argv)
{
  int k;
  gfx_event_t ev;
  int i;

  gfx_init(NULL, 600, 400, "Testing");
  gfx_SCREEN_0();

 gfx_iconlist_updates(Wicoli,0);
  for(i=1;i<argc;i++)
  {
     unsigned int iw, ih, *id;
     load_file(argv[i], 90, 160, &iw, &ih, &id);
     gfx_iconlist_insert(Wicoli, -1, argv[i], iw, ih, id, i*i, argv[i]);
     free(id);
  }
 gfx_iconlist_updates(Wicoli,1);
  
  while(1)
    if (gfx_event(NULL,&ev))
     switch(ev.type)
     {
     case GFXEV_QUIT: goto done;
       break;
     case Wicoli:
       printf("selected item no: %d  associated int: %d ptr: %s\n",
           ev.key, ev.wide, ev.usr);
       break;
     case Wbutton:
       k= gfx_get_selected(Wicoli);
       if (k!=-1)
        gfx_remove(Wicoli,k,NULL);
       break;
     }
done:
  gfx_close();
}
