#include <stdio.h>
#define MINIZ_IMPLEMENTATION
#include "../imports/miniz.c"


static size_t smin2(size_t a,size_t b) { return a<b?a:b; }

#define IN_BUFFER_SIZE  2048
#define OUT_BUFFER_SIZE 4096

static void write_bytes(unsigned char *B, int L)
{
  int i,W;
  unsigned char K;
  static int x;
  if (!B) { x= 0; return ; }
  for(i=0;i<L;i++)
  {
    K= B[i];
    W= K/100 ? 4 : (K/10?3:2);
    if (W+x>76) { printf("\n"); x= 0; }
    printf("%d,",K);
    x+= W;
  }
}

static int output_file(char *fn)
{
  FILE *inf;
  int R;
  int flush;
  size_t olen;
  int done;
  mz_stream MZ;
  unsigned char inbuffer[IN_BUFFER_SIZE];
  unsigned char outbuffer[OUT_BUFFER_SIZE];

  inf= fopen(fn,"rb");

  printf(" (unsigned char[]) {\n");
  memset(&MZ, 0, sizeof(MZ));
  MZ.next_in= inbuffer;
  MZ.avail_in= 0;
  MZ.next_out= outbuffer;
  MZ.avail_out= OUT_BUFFER_SIZE;

  mz_deflateInit(&MZ, 9);
  done= 0;
  flush= MZ_NO_FLUSH;
  while(flush!=MZ_FINISH)
  {
    R= fread(inbuffer, 1, IN_BUFFER_SIZE, inf);
    if (ferror(inf)) 
    {
      fprintf(stderr,"can't read\n");
      deflateEnd(&MZ);
      return 1;
    }
    MZ.next_in= inbuffer;
    MZ.avail_in= R;
    flush= feof(inf) ? MZ_FINISH : MZ_NO_FLUSH;
    while(MZ.avail_in)
    {
      mz_deflate(&MZ, flush );
      olen= OUT_BUFFER_SIZE - MZ.avail_out;
      if (olen) write_bytes(outbuffer, olen);
      done+= olen;
      MZ.next_out= outbuffer;
      MZ.avail_out= OUT_BUFFER_SIZE;
    }
  }
  printf("}, %d \n", done);
  fclose(inf);
  mz_deflateEnd(&MZ);
  fprintf(stderr,"done %s\n", fn);
  return 0;
}

int main(int argc,char **argv)
{
  int i;
  char *aname, *fname;
  for(i=1;i<argc;i+=2)
  {
    char *aname, *fname;
    aname= argv[i];
    fname= argv[i+1];
    printf(" { \"%s\", \n",aname);
    if (output_file(fname)) return 1;
    printf(" },\n");
  }
  return 0;
}
