#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>
#include <errno.h>


/***********************************************************************
 *                                                                     *
 *                              Extractor                              *
 *                                                                     *
 ***********************************************************************
  This program extracts a part of a source code. The part is marked
  with a comment in the form:
 ***********************************************************************/

  /** BEGIN: xxx **/
  /** END: xxx **/

/***********************************************************************
 ***********************************************************************/

void skipspc(char **s) { while(isspace(**s)) (*s)++; }

int chk(char **line, char *str, int len)
{
  int i;
  skipspc(line);
  for(i=0;i<len;i++)
   if ((*line)[i]!=str[i]) return 0;
  *line+= len;
  return 1;
}

int match(char **line, char *str)
{
  char *k;
  skipspc(&str);
  while(str[0])
  {
    k= str;
    for(;str[0];str++) if (isspace(*str))  break;
    if (!chk(line, k, str-k)) return 0;
    skipspc(&str);
  }
  return 1;
}


int ismark(char *line, char *type, char *mark)
{
  if (!match(&line,"/**")) return 0;
  if (!match(&line,type)) return 0;
  if (!match(&line,mark)) return 0;
  if (!match(&line, "**/")) return 0;
  return 1;
}

int main(int argc,char **argv)
{
  char *fn, *mark,*line;
  char buf[2048];
  FILE *f;
  size_t linesz;
  fn= argv[1]; mark= argv[2];
  f= fopen(fn,"rb");
  if (!f) exit(fprintf(stderr,"can't open %s: %s\n",fn, strerror(errno)));

  line= NULL;
  linesz= 0;
  while(getline(&line,&linesz,f)!=-1)
    if (ismark(line,"BEGIN:", mark)) break;

  while(getline(&line,&linesz,f)!=-1)
    if (ismark(line,"END:",mark)) break;
    else fwrite(line, 1, strlen(line), stdout);

  fclose(f);
  return 0;
}
